% Computes the synaptic junctions of both MD-AMM and ME-AMM models;
%
% >>> LearnMAMM('FILENAME',X);
% 
% Inputs:
% 	FILENAME - The name of the file in which the synaptic junctions will be stored;
% 	X - Matrix with dimensions [N,3,K], where N is the number of three-valued elements and K is the number of itens.
%	    In other words, each X(:,:,k) corresponds to a N-dimensional three-valued pattern. 
% Output:
% 	A file with the synaptic junctions.
%  
% REFERENCE:
% Valle, M.E., "A Class of Sparsely Connected Autoassociative Morphological Memories for Large Color Images",
% Accepted to be published at IEEE Neural Networks.
%
