%
% An example of the multivalued MAMs for the restoration of a pattern corrupted with pepper noise;
%
%
% THIS EXAMPLE HAVE BEEN TESTES ON GNU OCTAVE 3.0 ON A DEBIAN-LINUX OPERATING SYSTEM;
% The commands imread and imwrite may differ on MATLAB or other versions of GNU Octave.
% Moreover, it is expected that you have compliled the mex-files in MATLAB or GNU Octave.
% For example, in the Octave for Linux (Debian and variations such as Ubuntu), 
%   type the following commands in the Terminal:
% 	$ mkoctfile --mex LearnMAMM.c
%	$ mkoctfile --mex MDAMM.c
%	$ mkoctfile --mex MEAMM.c
%
%

% Get Color Images of size 512x512;
clear;
k=1; A(:,:,:,k)=imread("anhinga.jpg");

k=k+1; A(:,:,:,k)=imread("athens.jpg");

k=k+1; A(:,:,:,k)=imread("avion.jpg");

k=k+1; A(:,:,:,k)=imread("baboon.jpg");

k=k+1; A(:,:,:,k)=imread("bardowl.jpg");

k=k+1; A(:,:,:,k)=imread("barnfall.jpg");

k=k+1; A(:,:,:,k)=imread("beeflowr.jpg");

k=k+1; A(:,:,:,k)=imread("bird.jpg");

k=k+1; A(:,:,:,k)=imread("blakeyed.jpg");

k=k+1; A(:,:,:,k)=imread("blueeye.jpg");

k=k+1; A(:,:,:,k)=imread("bluheron.jpg");

k=k+1; A(:,:,:,k)=imread("bobcat.jpg");

A=double(A)/255;
N=size(A,1);

% Converting images to vectors...
clear X; X=reshape(A,N*N,3,k); clear A;

% Learning phase...
LearnMAMM('J',X);
% It may take some time, but you can comment the previous line once J have been computed!

% Create a patter with pepper noise with probability Pr...
Pr=0.1; xr=X(:,:,1);
for i=1:N*N
	if rand<Pr
		xr(i,:)=[0,0,0];
	end
end

% Recalling the patterns and using the MD-AMM and ME-AMM models...
y=MDAMM('J',xr);
z=MEAMM('J',xr);

% Saving the images in the files MDAMM_recalled.jpg and MEAMM_recalled.jpg...
imwrite('MDAMM_recalled.jpg',255*reshape(y(:,1),N,N),255*reshape(y(:,2),N,N),255*reshape(y(:,3),N,N));
imwrite('MEAMM_recalled.jpg',255*reshape(z(:,1),N,N),255*reshape(z(:,2),N,N),255*reshape(z(:,3),N,N));


